/*---------------------------------------------------------------------------*
 * Operating Systems I                                                       *
 *---------------------------------------------------------------------------*
 *                                                                           *
 *                                  G A T E                                  *
 *                                                                           *
 *---------------------------------------------------------------------------*/

#ifndef __Gate_include__
#define __Gate_include__

#include "object/chain.h"

/**
 * Class Gate is the superclass of a set of classes that are able to handle 
 * interrupts. Every subclass of Gate has to implement the methods prologue() 
 * and epilogue that implement the appropriated behavior of the handler. These
 * methods enable us to devide the handeling of an interrupt into an
 *
 * To be able to synchronise the epilogues the Gate object has to store called
 * epilogues. Therefore Gate is derived from Chain. A simple flag tells if this
 * Gate object is curently waiting to be executed.
 */

class Gate   {
  
  /** TRUE if an epilogue is waiting to be executed. */
  
  /* ToDo: insert sourcecode */ 
public:
  Gate ()   {}
   
  /**
   * Method prologue() is immediately called if an interrupt occurs, 
   * implementing activities that have to be executed asynchronous to other
   * activities of the operating system.  To enalbe different behavior according 
   * to the occured interrupt this method has to be implemented in subclasses 
   * of Gate.
   *
   * @return TRUE if method epilogue() has to be executed afterwards.
   */
  
  /* ToDo: insert sourcecode */ 

  /**
   * Method epilogue() implements the secound part of the interrupt handleing. 
   * This part is executed synchronously to other activities of the operating 
   * system and will only be called if necessary. Just as method prologue() it 
   * has to be implemented in the subclasses of Gate.
   */
  
  /* ToDo: insert sourcecode */ 

  /**
   * Method queued() sets a flag telling if an epilogue is curently waiting to
   * be executed.
   *
   * @param q TRUE if an epilogue is waiting otherwise FALSE
   */
  
  /* ToDo: insert sourcecode */ 

  /**
   * Method queued() tests if an epilogue is curently waiting to be executed.
   *
   * @return TRUE if an epilogue is curently waiting to be executed.
   */
  
  /* ToDo: insert sourcecode */ 
};

#endif
